//
//  AppController.h
//  Otis
//
//  Created by Dan Grover on 1/20/07.
//  Copyright 2007 Wonder Warp Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class WWOtisGame;
@class WWOtisView;
@class WWOtisScoreboard;
@class LCDCell;
@class WWOtisBlock;
@class WWOtisPrefsController;
@class iTableColumnHeaderCell;
@class AnimatingTabView;
#import "PolishedWindow.h"

@interface AppController : NSObject 
{
	IBOutlet WWOtisView *myView;
	IBOutlet WWOtisGame *myGame;
	IBOutlet WWOtisScoreboard *myScoreboard;
	IBOutlet PolishedWindow *myWindow;
	IBOutlet NSWindow *settingsSheet;
	IBOutlet NSWindow *prefsWindow;
	IBOutlet NSPopUpButton *sizeChooser;
	IBOutlet NSPopUpButton *difficultyChooser;
	IBOutlet NSMenuItem *abortGame;
	
	
	IBOutlet NSPopUpButton *scoresDiffChooser;
	IBOutlet NSPopUpButton *scoresSizeChooser;
	IBOutlet NSButton *cancelButton;
	IBOutlet AnimatingTabView *tabView;
	IBOutlet NSTableView *highScoresTable;

	
	// High scores stuff
	IBOutlet NSWindow *scoreSheet;
	IBOutlet NSButton *scoreCancel;
	IBOutlet NSButton *scoreOK;
	IBOutlet NSTextField *scoreHeading;
	IBOutlet NSTextField *scoreName;
	
	NSTimer *timer;
	
	
	NSSound *startSound;
	
	IBOutlet NSApplication *app;
}



- (id)init;
- (void)awakeFromNib;
- (NSSize)windowWillResize:(NSWindow *)sender toSize:(NSSize)proposedFrameSize;
- (void)windowDidResize:(NSNotification *)aNotification;
- (void)fixWindow;
- (void)resizeWindowOnSpotWithRect:(NSRect)aRect withWindow:(NSWindow *)aWindow;
- (void)windowWillClose:(NSNotification *)aNotification;
- (IBAction) showNewGameSheet: (id)sender;
- (IBAction) hideNewGameSheet: (id)sender;
- (IBAction) showHighScores:(id)sender;
- (IBAction) startGame: (id)sender;
- (IBAction) showSplash: (id)sender;
- (IBAction) highScoresViewChanged: (id)sender;
- (void) startNewGameWithSize:(int)newSize difficulty:(int) newDiff;
- (void) gameOver;
- (IBAction) insertHighScore:(id)sender;
- (IBAction) cancelHighScore:(id)sender;
- (IBAction) showHowToPlay:(id)sender;
- (NSString *)nameForDiff:(int)diff;
- (NSString *)nameForSize:(int)size;
- (IBAction) setUpCube:(id)sender;
- (IBAction) sendFeedback:(id)sender;
- (IBAction) donate:(id)sender;
- (float)goodHeight;
- (IBAction) shoveboxLink:(id)sender;
- (IBAction) simplechordLink:(id)sender;
@end
